Cannot update wiki page via REST API
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 2.5.1

Description

Environment:

Redmine version                2.5.1.stable

Ruby version                   2.0.0-p481 (2014-05-08) [x86_64-linux]

Rails version                  3.2.17

Environment                    production

Database adapter               Mysql2

I am trying to update the content of a wiki page via REST API but I always get an error message complaining that I am posting no

content: "text field can't be blank".

I am using the following CURL invocation:

curl -X PUT http://MY-API-KEY@redmine.lan/redmine/projects/foo/wiki/bar.xml -d "<?xml version="1.0

"?>

<wiki_page>

  <text>Example</text>

  <comments>Typo</comments>

</wiki_page>" 

 and I get the following error message:

<?xml version="1.0" encoding="UTF-8"?><errors type="array"><error>Text field can't be blank

</error></errors>

 The production log shows the following:

Processing by WikiController#update as XML

  Parameters: {"<?xml version"=>"1.0?>\n<wiki_page>\n  <text>Example</text>\n  <comments>Typo

</comments>\n</wiki_page>", "project_id"=>"foo", "id"=>"bar"}

  Current user: user1 (id=23)

  Rendered common/error_messages.api.rsb (0.2ms)

 The error is the same, regardless of the fact that wiki page already exists or not.

History

#1 - 2014-05-28 14:49 - gianmaria romanato

I found out that the main page of the REST API documentation states that the content type must be specified in the request.

curl -s -H "Content-Type: application/json" -X PUT ...

 Note that I also switched from XML to JSON, because when downloading wiki pages as JSON blanks are preserved (e.g. \t \n) while they are lost in

XML format.

This defect should be closed as rejected.

#2 - 2014-05-28 14:56 - gianmaria romanato

- Status changed from New to Resolved

#3 - 2014-06-22 17:25 - Toshi MARUYAMA
- Status changed from Resolved to Closed

#4 - 2014-06-22 17:26 - Toshi MARUYAMA

- Resolution set to Invalid

#5 - 2014-09-30 21:18 - Alex Last

we tried both JSon and XML and various content types with Redmine 2.5.2 and we always get "Text field can't be blank" error.
